//=========================================================
//
// カード
//
//=========================================================

#ifndef _AI_CARD_
#define _AI_CARD_

#include <vector>
#include <string>

#include "Define.h"

using namespace std;

namespace AI_Modules {

	//=========================================================
	// グリッドへの影響
	//=========================================================
	struct GridAffection {

		int x;
		int y;
		int movableDirection;

		int TurnedX ( int direction ) {

			int result = 0;

			if      ( direction == DIRECTION::UP)   { result = x;}
			else if ( direction == DIRECTION::LEFT) { result = y;}
			else if ( direction == DIRECTION::RIGHT){ result = -y;}
			else if ( direction == DIRECTION::DOWN) { result = -x;}

			return result;
		}

		int TurnedY ( int direction ) {

			int result = 0;

			if      ( direction == DIRECTION::UP)   { result = y;}
			else if ( direction == DIRECTION::LEFT) { result = -x;}
			else if ( direction == DIRECTION::RIGHT){ result = x;}
			else if ( direction == DIRECTION::DOWN) { result = -y;}

			return result;
		}

		int TurnedIndecrion ( int direction ) {

			int result = DIRECTION::NONE;

			if      ( direction == DIRECTION::UP)   { result = movableDirection;}

			else if ( direction == DIRECTION::LEFT) { 

				if      ( movableDirection == DIRECTION::UP)   { result = DIRECTION::LEFT;}
				else if ( movableDirection == DIRECTION::LEFT) { result = DIRECTION::DOWN;}
				else if ( movableDirection == DIRECTION::DOWN) { result = DIRECTION::RIGHT;}
				else if ( movableDirection == DIRECTION::RIGHT){ result = DIRECTION::UP;}
			}

			else if ( direction == DIRECTION::RIGHT){ 

				if      ( movableDirection == DIRECTION::UP)   { result = DIRECTION::RIGHT;}
				else if ( movableDirection == DIRECTION::LEFT) { result = DIRECTION::UP;}
				else if ( movableDirection == DIRECTION::DOWN) { result = DIRECTION::LEFT;}
				else if ( movableDirection == DIRECTION::RIGHT){ result = DIRECTION::DOWN;}

			}

			else if ( direction == DIRECTION::DOWN) {

				if      ( movableDirection == DIRECTION::UP)   { result = DIRECTION::DOWN;}
				else if ( movableDirection == DIRECTION::LEFT) { result = DIRECTION::RIGHT;}
				else if ( movableDirection == DIRECTION::DOWN) { result = DIRECTION::UP;}
				else if ( movableDirection == DIRECTION::RIGHT){ result = DIRECTION::LEFT;}
		
			}


			return result;
		}

	};

	//=========================================================
	// プロパティ
	//=========================================================
	struct Card {

		int    processId;

		vector<GridAffection> gridAffectionList; // 向きニュートラル（UP時のもの）

		Card() {
			processId = -1;
		}
	};

};
#endif





