//=========================================================
//
// ProgressBar (declare)
//
//=========================================================

#ifndef _PROGRESS_BAR_
#define _PROGRESS_BAR_

#include <map>
#include <vector>
#include <string>

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

using namespace std;

namespace GUI_SFML {


	class ProgressBar {

		public:

			ProgressBar( sf::Vector2f size, float maxValue, string unit = "");
			~ProgressBar();

			void Update(sf::RenderWindow &window);
			void Draw(sf::RenderWindow &window);

			void SetPosition(sf::Vector2f arg) { _position = arg; }
			void SetPosition( float x, float y) { _position.x = x; _position.y = y; }
			void SetPositionX( float x ) { _position.x = x; }
			void SetPositionY( float y ) { _position.y = y; }
		
			void AddValue ( float value ) { _goalValue += value; if ( _goalValue > _maxValue) { _goalValue = _maxValue; } }
			void SetValue ( float value ) { _goalValue = value;  if ( _goalValue > _maxValue) { _goalValue = _maxValue; } }
			void SetValue_Forsibly ( float value ); 

			void SetVanishCountDown(int arg) { _vanishCountDown = arg; }

	protected:

			sf::Vector2f _position;
			sf::Vector2f _size;
			string       _unit;

			sf::Image   _number_Image;
			sf::Texture _number_Texture;
			sf::Sprite  _number_Sprite;

			sf::RectangleShape _frame;
			sf::RectangleShape _base;
			sf::RectangleShape _bar;

			float _currentValue;
			float _goalValue;
			float _maxValue;


			int _vanishCountDown;

	private:

		//=========================================================
		// 更新処理メイン部分
		//=========================================================
		void Update_Main();

		//=========================================================
		// バーの長さを更新
		//=========================================================
		void Update_Bar();

		//=========================================================
		// 進捗率を求めて更新
		//=========================================================
		void Update_ProgressRate();
	};
}
#endif

