//=========================================================
//
// 読み返しログビューワー
//
//=========================================================

#ifndef _SCENARIO_LOG_VIEWER_
#define _SCENARIO_LOG_VIEWER_

#include <map>
#include <vector>
#include <string>

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

class IScenarioLogger;

using namespace std;

namespace GUI_SFML {
	
	class ScrollBar;

	class ScenarioLogViewer {

		public:

			ScenarioLogViewer ();
			~ScenarioLogViewer ();

			void Update(sf::RenderWindow &window);
			void Draw(sf::RenderWindow &window);
			
			//void ReadFile ( string fileName );
			void ReadLog ();
			
			bool IsGoOverTheBottom() { return _isGoOverTheBottom; }
			
			void SetScenarioLogger ( IScenarioLogger *obj  ) { _scenarioLogger = obj; }
			
		private:
			
			IScenarioLogger *_scenarioLogger;
			
			sf::Vector2f _position;
			
			sf::RectangleShape _base;
			
			sf::Font _font;
			
			vector<sf::Text> _rowList;
			
			ScrollBar *_scrollBar;
			
			int _displayRowNum;
			
			bool _isGoOverTheBottom;
			
			int GetLineCount ( string fileName );
	};
}
#endif

