//=========================================================
//
// ScrollBar (declare)
//
//=========================================================

#ifndef _SCROLL_BAR_
#define _SCROLL_BAR_

#include <map>
#include <vector>
#include <string>

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

using namespace std;

namespace GUI_SFML {

	class Button;

	class ScrollBar {

	public:

		ScrollBar();
		~ScrollBar();

		void Update(sf::RenderWindow &window);
		void Draw(sf::RenderWindow &window);

		void SetPosition(sf::Vector2f arg);
		void SetFrameSize(sf::Vector2f arg);
		sf::Vector2f GetFrameSize() { return _frameSize; }
		
		
		void SetActualLength( int arg );   // 全部でこれだけ入ってます
		void SetDisplayLength(int arg); // でも、表示できるのはこれだけです

		int  GetCurrentIndex();
		
		int  GetCurrentBarPosition ();
		void SetCurrentBarPosition ( int posY );

		void IsUpDownButton( bool arg ) { _isUpDownButton = arg; }
		
		void MoveToBottom(); // 最下段まで移動
		void MoveToTop();    // 最上段まで移動
		
		void MoveUp   (int count);
		void MoveDown (int count);
		
		bool IsBottom(); // 最下段？

	private:

		sf::Vector2f _position;
		sf::Vector2f _frameSize;

		bool _isUpDownButton;
		Button *_button_Up;
		Button *_button_Down;

		float _length_of_oneItem;

		//int _maxLength;
		int _actualLength;
		//int _currentIndex;
		int _displayLength;


		sf::RectangleShape _base;
		sf::RectangleShape _bar;


		sf::Vector2f _barPosition;
		sf::Vector2f _barSize;

		bool _isMouseOver;
		int _mouseX_previous;
		int _mouseY_previous;

		void MakeBarShape();

		bool IsMouseOver_to_Bar(int mouseX, int mouseY);
		bool IsMouseOver_to_BarUpper(int mouseX, int mouseY);
		bool IsMouseOver_to_BarDownner(int mouseX, int mouseY);

		float GetBarMoveLength_par_OneItem();
		
		
		void AdjustPosition();
	};
}

#endif

