//=========================================================
//
// テキスト表示部分の「１文字」
//
//=========================================================

#ifndef _TEXT_CHAR_
#define _TEXT_CHAR_

#include <string>
#include <SFML/Graphics.hpp>

using namespace std;

namespace GUI_SFML {

	class TextChar {

	public:

		static const int TEXT_CHAR_TYPE_CHARACTER;
		static const int TEXT_CHAR_TYPE_NEW_LINE;
		static const int TEXT_CHAR_TYPE_NEW_PAGE;
		static const int TEXT_CHAR_TYPE_WAIT_CLICK;

		TextChar(string c);
		TextChar(string c, int size, int type);
		TextChar(string c, int size, int type, sf::Color color);
		~TextChar();

		void Update ( sf::RenderWindow &window );
		void Draw   ( sf::RenderWindow &window );

		int GetWidth ();
		int GetHeight();

		bool GetVisible()           { return _isVisible; }
		void SetVisible( bool arg ) { _isVisible = arg; }
		
		void SetPosition ( sf::Vector2f position  ) { _position = position; } 
		sf::Vector2f GetPosition () { return  _position; } 

		int GetType() { return _type; }

		void SetColor ( sf::Color color ) { _sprite.setColor(color); }

		string GetChar() { return _char; }
		
		void SetRuby ( string ruby );
	private:

		string _char; // 一応、文字を持つ。
		bool _isVisible;

		int _type;

		sf::Vector2f _position;
		sf::Image   _image;
		sf::Texture _texture;
		//sf::Sprite  _sprite;
		sf::Text _sprite;
		
		int _width;
		
		sf::Text _ruby;

		void Init ( string c, int size, int type, sf::Color color );
	};
};
#endif
