//=========================================================
//
// TextImageFactory Class for SFML (daclare)
//
//=========================================================

#ifndef _TEXT_IMAGE_FACTORY_
#define _TEXT_IMAGE_FACTORY_

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

#include <string>
#include <vector>


using namespace std;

class TextImageFactory {

public:

	static int       _defaultFontSize;
	static sf::Color _defaultColor;


	TextImageFactory();
	~TextImageFactory();

	static void Create(sf::Image &resultImage, string text, int fontSize = _defaultFontSize, sf::Color color = _defaultColor);

	static void Create(
		int newLineWidth,
		int spaceBetweenRows,// sf::Vector2<int> space_betweenChars,
		sf::Image &resultImage, string text, int fontSize = _defaultFontSize, sf::Color color = _defaultColor);


	static bool SetFont ( std::string fontFileName );
	
	static sf::Text Create ( std::string text, int fontSize );
	
	//static int _width;

	static sf::Font _font;
	static string _fontFileName;

private:

	
	struct FontDotData {
		unsigned long codePoint;
		sf::Glyph glyph;
		vector<vector<sf::Color> > dotTable;
		int offsetX;
		int offsetY;
	};
	

	//=========================================================
	// 参考：http://www.ryusuke.net/archives/601
	//=========================================================
	//static unsigned long utf8ToUtf32(unsigned char *input, int &bytesInSequence);
	static unsigned int utf8ToUtf32(unsigned char *input, int &bytesInSequence);
};
#endif










