//=========================================================
//
// 矢印クラス
//
//=========================================================

#include "Arrow.h"
#include <math.h> 

//=========================================================
// コンストラクタ
//=========================================================
Arrow::Arrow() {
	_isActive = true;
}
//=========================================================
// デストラクタ
//=========================================================
Arrow::~Arrow() {
	
}

//=========================================================
// 初期設定
//=========================================================
void Arrow::Init ( sf::Vector2f posFrom, sf::Vector2f posTo ) {
	
	// 一応覚えておくよ。
	_positionFrom = posFrom;
	_positionTo   = posTo;
	
	
	// 少し短めにして、先端の三角からハミ出ないようにする
	int width  = Utils_Cal::GetDistance ( posFrom.x, posFrom.y, posTo.x, posTo.y ) - 15.0f;
	int height = 5;
	
	_lineRect = sf::RectangleShape ( sf::Vector2f ( width, height  ) );
	
	int posX = (posFrom.x + posTo.x) / 2;
	int posY = (posFrom.y + posTo.y) / 2;
	
	_lineRect.setPosition ( posX, posY );
	_lineRect.setOrigin(
		(_lineRect.getSize().x / 2.0f) + 15.0f, // 少し短めにした分、少しゲタをはかせる
		_lineRect.getSize().y / 2.0f
	);
	
	float angle = Utils_Cal::GetAngleOfLineBetweenTwoPoints ( posFrom.x,posFrom.y, posTo.x,posTo.y );
	_lineRect.rotate ( angle );
	
	_lineRect.setOutlineThickness (1);
	_lineRect.setFillColor    ( sf::Color(0,0,0,255) );
	_lineRect.setOutlineColor ( sf::Color(0,0,0,255) );
	
	// 先端の三角
	_arrowPart = sf::CircleShape ( 20, 3 );
	_arrowPart.setFillColor ( sf::Color(0,0,0,255) );
	_arrowPart.setPosition ( posTo );
	
	_arrowPart.setOrigin (
		_arrowPart.getRadius(), 0
	);
	
	_arrowPart.rotate ( angle + 90.0f);
}

//=========================================================
// 更新
//=========================================================
void Arrow::Update ( sf::RenderWindow &window ) {
	
	// 処理なし
}
//=========================================================
// 描画
//=========================================================
void Arrow::Draw   ( sf::RenderWindow &window ) {

	if ( _isActive ) {
		window.draw ( _lineRect );
		window.draw ( _arrowPart );
	}
	
}
	
	








