//=========================================================
//
// カメラクラス
// 
//=========================================================

#ifndef _CAMERA_
#define _CAMERA_

#include <SFML/Window.hpp>
#include <SFML/Graphics.hpp>

class Camera {
	
	
public:
	
	static string CURRENT_ACTION_NONE;
	static string CURRENT_ACTION_MOVETO; // 複数の機能を持たせるとして、複数の動作が平行して実行される場合はどうなるの？
	
	Camera();
	~Camera();
	
	void Update();
	
		
	void Reset();
	void MoveTo ( int x, int y, int speed = 1 );
	void Move ( int x, int y);
	void SetPosition ( int x, int y );
	
	void VerticalReverse ( bool arg );
	
	void ApplyThisCameraToTheActualScreen();
	
	bool IsActionEnd();


	//=========================================================
	// セーブ/ロード用のインターフェイス
	//=========================================================
	struct SaveData {
		
		// 位置情報だけを再現対象とする
		// 移動アクション中にセーブされたときは、目的地を「現在地」ということにしてアクションは無効とする
		
		int centerX;
		int centerY;
		
		SaveData() {
			centerX = 0;
			centerY = 0;
		}
	};
	SaveData GetSaveData ();
	void Load ( SaveData &saveData );
	
private:
	
	sf::View _view;
	
	string _currentAction;
	
	string _verticalReverseStatus;
	
	int _goalX;
	int _goalY;
	
	int _speed;
	
	void Action_MoveTo();
	
	void Action_VerticalStatus();
	
	bool _IsVerticalRotate;
	
};


#endif;
