//=========================================================
//
// 現在の手番表示パネル
//
//=========================================================

#include "CurrentTurnNamePanel.h"
#include "../GUI_SFML/TextImageFactory.h"
#include "TextLabel.h"
#include "../Utils/Utils_Convert.h"
#include "../Utils/Utils_Cal.h"
#include "../GUI_SFML/SFML_Utils.h"


//=========================================================
// コンストラクタ
//=========================================================
CurrentTurnNamePanel::CurrentTurnNamePanel() {
	
	_name      = "";
	_tobeText  = "";
	//_textLabel = NULL;

	/*
	_textLabel = new TextLabel("none");
	_textLabel->SetFont ( TextImageFactory::_font);
	_textLabel->SetText("NONE");
	_textLabel->SetSize ( 24 );
	_textLabel->SetColor ( sf::Color(255,255,255,255) );
	*/
	
	_textLabel.setFont  ( TextImageFactory::_font); 
	_textLabel.setString ( GUI_SFML::SFML_Utils::GetSfString("現在の手番") );
	//_textLabel.setCharacterSize ( 18 );
	//_textLabel.setColor ( sf::Color(255,255,255,255) );

	_textLabel.setCharacterSize ( 16 );
	_textLabel.setColor ( sf::Color::White );
	
	SetPosition ( sf::Vector2f(0.0f, 0.0f) );
	
	//_backRect = sf::RectangleShape ( sf::Vector2f ( 0.0f, 0.0f ) );
	
}
//=========================================================
// デストラクタ
//=========================================================
CurrentTurnNamePanel::~CurrentTurnNamePanel() {
	
}

//=========================================================
// 値を設定
//=========================================================
void CurrentTurnNamePanel::SetName ( string name ) {
	
	_name = name;
	
	_tobeText = "現在の手番：" + name;
	
	_textLabel.setString ( GUI_SFML::SFML_Utils::GetSfString (_tobeText) );
	
	sf::FloatRect textSize = _textLabel.getGlobalBounds();
	
	float textOriginX = textSize.width  / 2.0f;
	float textOriginY = textSize.height / 2.0f;
	Utils_Cal::RoundWildly (textOriginX);
	Utils_Cal::RoundWildly (textOriginY);
		
	_textLabel.setOrigin ( sf::Vector2f ( textOriginX, textOriginY ) );
	
	_backRect = sf::RectangleShape ( sf::Vector2f ( textSize.width + 15.0f, textSize.height + 10.0f ) );
	//_backRect.setFillColor ( sf::Color ( 120, 120, 120, 200 )  );
	_backRect.setFillColor ( sf::Color ( 70, 70, 70, 150 )  );

	_backRect.setOutlineColor ( sf::Color::Black  );
	_backRect.setOutlineThickness ( 1 );


	_backRect.setOrigin ( _backRect.getGlobalBounds().width / 2.0f, _backRect.getGlobalBounds().height / 2.0f - 2.0f );
	
	SetPosition ( _position );

}

//=========================================================
// 位置を設定
//=========================================================
void CurrentTurnNamePanel::SetPosition  ( sf::Vector2f pos ) {
	
	_position = pos;
	//printf("-----\n");
	//printf ("_textLabel [%d]\n", _textLabel);
	_textLabel.setPosition ( _position );
	_backRect.setPosition ( _position );
	
	//printf("-----\n");
	
}

//=========================================================
// 更新
//=========================================================
void CurrentTurnNamePanel::Update ( sf::RenderWindow &window ) {
	
	if ( _name != "" ) {
		
	}
	
}
//=========================================================
// 描画
//=========================================================
void CurrentTurnNamePanel::Draw   ( sf::RenderWindow &window ) {

	if ( _name != "" ) {
		
		window.draw ( _backRect );
		window.draw ( _textLabel );
		
	}


}

	
	
