//=========================================================
//
// Defines
//
//=========================================================

#ifndef _DEFINES_
#define _DEFINES_

#include <string>

using namespace std;

namespace APPLICATION {

	namespace WINDOW_SIZE {
		const int WIDTH  = 800;
		const int HEIGHT = 600;
	};

};


namespace MOUSE {

	namespace BUTTON {

		const int LEFT       = 0;
		const int RIGHT      = 1;

		namespace STATE {

			const int PRESS   = 0;
			const int RELEASE = 10;
			const int NONE    = 100;
			const int HAVE_PRESSED = 1000;
		};
	};
};

namespace SCRIPT {

	namespace UNIT_TYPE {

		///// スクリプトファイルから読み込むので、文字列の方が相性がいい。
		const string NONE                = "";
		const string PUT_TEXT            = "Text";
		const string TEXTAlias_Regist    = "TextAlias_Regist";
		const string PROTAGONIST_Regist  = "Protagonist_Regist";
		const string DEFINE_TEXT_WINDOW  = "DefineTextWindow";
		const string TEXT_WINDOW_Design  = "CurrentTextWindowDesign";
		const string Skipping            = "Skipping";
		const string PRINT               = "Print";
		const string SYSTEM_MESSAGE      = "SystemMessage";
		const string IMAGE               = "Image";
		const string IMAGE_Regist        = "Image_Regist";
		const string IMAGE_Group         = "ImageGroup";
		const string BGM_Regist          = "BGM_Regist";
		const string BGM_Change          = "BGM_Change";
		const string BGM_Config          = "BGM_Config";
		const string Sound_Regist        = "Sound_Regist";
		const string Sound               = "Sound";
		const string TextLabel           = "TextLabel";
		const string Select              = "Select";
		const string Variable_Define     = "Variable_Define";
		const string Variable_Release    = "Variable_Release";
		const string Variable_Operation  = "Variable_Operation";
		const string Variable_Console    = "Variable_Console";
		const string IF                  = "IF";
		const string Switch              = "Switch";
		const string Gosub               = "Gosub";
		const string Button              = "Button";
		const string Game                = "Game";
		const string Game_Release        = "Game_Release";
		const string Move                = "Move";
		const string Put                 = "Put";
		const string Remove              = "Remove";
		const string RemoveAll           = "RemoveAll";
		const string WatchEvent          = "WatchEvent";
		const string WatchGameOperation  = "WatchGameOperation";
		const string Battle              = "Battle";
		const string AstralProjection    = "AstralProjection";
		const string Jump                = "Jump";
		const string Wait                = "Wait";
		const string WaitClick           = "WaitClick";
		const string Fade                = "Fade";
		const string Shake               = "Shake";
		const string Save                = "Save";
		const string Load                = "Load";
		const string WriteSaveData       = "WriteSaveData";
		const string Title               = "Title";
		const string Chapter             = "Chapter";
		const string Camera              = "Camera";
		const string FileSelect          = "FileSelect";
		const string ClickableImage      = "ClickableImage";
		const string ClearClickableImage = "ClearClickableImage";
		const string DefineControlTag    = "Define_ControlTag";
		const string WaitForClickableImages = "WaitForClickableImages";
		const string FreeBattleSelector  = "FreeBattleSelector";
	};

};

namespace DIRECTION {

	const int NONE  = 0;
	const int LEFT  = 1;
	const int RIGHT = 2;
	const int UP    = 3;
	const int DOWN  = 4;

};

namespace CONFIG {
	
	const string FileName = "./data/config.txt";

	namespace KEY {
		const string VolumeBGM = "VOLUME_BGM";
		const string VolumeSE  = "VOLUME_SE";
	};
	
	namespace DEFAULT {
		const float VolumeBGM = 100.0f;
		const float VolumeSE  = 100.0f;
	};
};

#endif
