//=========================================================
//
// いわゆる右クリックメニューですよー。
//
//=========================================================

#ifndef _MENU_SO_COLLED_RIGHT_CLICK_MENU_OR_SOMETHING_
#define _MENU_SO_COLLED_RIGHT_CLICK_MENU_OR_SOMETHING_

#include <SFML/Graphics.hpp>
#include <string>
using namespace std;

#include "../GUI_SFML/Button.h"
#include "../GUI_SFML/Slider.h"

class SaveDataManager;
class ScriptEngine;
class MenuItem;

class Menu {

public:

	Menu( ScriptEngine *scriptEngine );
	~Menu();


	void Update ( sf::RenderWindow &window );
	void Draw   ( sf::RenderWindow &window );

	///// 表示/非表示
	bool IsActive() { return _isActive; }
	void SetActive ( bool value );
	
	///// セーブ/ロードウィンドウを開く（外部から、ということ。要するにスクリプトのタグで、ということ。メニューを経由せずに）
	void OpenSaveWindow();
	void OpenLoadWindow();
	

	///// 設定項目の値を取得
	string GetItemValue ( string itemName );
	void   SetItemValue ( string itemName, string value );
	
	int   GetVolumeBGM ();
	void  SetVolumeBGM ( int value );
	int   GetVolumeSE ();
	void  SetVolumeSE ( int value );

private:

	struct Image_Set {
		string      fileName;
		sf::Image   image;
		sf::Texture texture;
		sf::Sprite  sprite;

		Image_Set () {
			fileName = "";
		}
	};
	
	// 持ち主
	ScriptEngine *_scriptEngine;

	// 表示中？ これは結構重要ですよ。
	bool _isActive;
	
	// つまり、メニューを経由せずにスクリプトでセーブロードウィンドウを開いたときには閉じ次第、メニューも閉じるよ、ということ。
	bool _closeSoonAfter;

	sf::Vector2f       _position;     // 位置。デフォルトで画面の左上
	sf::RectangleShape _back_Frame;   // 下地。デフォルト用
	Image_Set          _back_Image;   // 下地。背景画像。設定してもいいのですよ。

	GUI_SFML::Button *_button_Save;
	GUI_SFML::Button *_button_Load;
	GUI_SFML::Button *_button_backToTitle;
	
	
	bool _isConfirmBacktoTitleDisplay;
	GUI_SFML::Button *_button_yes;
	GUI_SFML::Button *_button_no;
	sf::Text _text_backToTitleConfirm;
	sf::RectangleShape _back_confirmWindow;
	

		
	GUI_SFML::Slider *_slider_Volume_BGM;
	GUI_SFML::Slider *_slider_Volume_SE;
	
	sf::Text _text_Volume_BGM;
	sf::Text _text_Volume_SE;
	
	Image_Set _shortcutKeys_Image;
	

	vector<MenuItem*> _itemList; // 設定項目リスト

	SaveDataManager *_saveDataManager;


	int _mouseState; // 右クリックの、状態。

	//=========================================================
	// 内部定数
	//=========================================================
	static const int MOUSE_STATE_NONE;    // 押していない
	static const int MOUSE_STATE_PRESS;   // 押している
	static const int MOUSE_STATE_RELEASE; // 放したところ

	//=========================================================
	// マウスの状態を監視
	//=========================================================
	void ObserveMouseState ( sf::RenderWindow &window );

};
#endif


