//=========================================================
//
// 既読管理クラス Read は 過去形または過去分詞の Read
//
//=========================================================

#include "ReadTextManager.h"

//=========================================================
// なんだか定数
//=========================================================
const int ReadTextManager::ALL_FINISHED = -1; // 何文字目、じゃなくて、この数値だったら全部読んだ、を表すとする。

//=========================================================
// コンストラクタ
//=========================================================
ReadTextManager::ReadTextManager() {

	// することある？ ないと思いますー。
}

//=========================================================
// デストラクタ
//=========================================================
ReadTextManager::~ReadTextManager() {

	// することある？ ないと思うですー。
}

//=========================================================
// このユニットは既読になりました
//=========================================================
void ReadTextManager::Finished ( string processLabel, int unitIndex ) {

	_readData [ processLabel ][ unitIndex ] = ALL_FINISHED;
}

//=========================================================
// このユニットのｎ文字目まで既読になりました
//=========================================================
void ReadTextManager::Finished ( string processLabel, int unitIndex, int byThisCharIndex ) {

	// より小さな値を受け取ったら？
	int currentValue = GetRecord ( processLabel, unitIndex );

	if ( byThisCharIndex <= currentValue ) {
		
		// 上書きは、しない。

	} else {

		// より大きい値のときだけ、レコードを更新
		_readData [ processLabel ][ unitIndex ] = byThisCharIndex;
	}
}

//=========================================================
// このユニットは既読ですか？
//=========================================================
bool ReadTextManager::IsFinished ( string processLabel, int unitIndex ) {

	bool result = false;

	// 指定ラベルのプロセスがある？
	map <string, map<int,int>>::iterator findProcessIt =  _readData.find( processLabel );
	if ( findProcessIt != _readData.end() ) {

		// 指定番号のユニットがある？
		map <int, int>::iterator findUnitIt = findProcessIt->second.find( unitIndex );
		if ( findUnitIt != findProcessIt->second.end()) {

			if (findUnitIt->second == ALL_FINISHED) {

				result = true;
			}
		}
	}

	return result;
}

//=========================================================
// このユニットは何文字目まで既読ですか？
//=========================================================
int ReadTextManager::GetReadFinishedLength ( string processLabel, int unitIndex ) {

	///// プロセスやユニットがないときは、0（いっこも既読じゃない）とする
	int result = 0;

	// 指定ラベルのプロセスがある？
	map <string, map<int,int>>::iterator findProcessIt =  _readData.find( processLabel );
	if ( findProcessIt != _readData.end() ) {

		// 指定番号のユニットがある？
		map <int, int>::iterator findUnitIt = findProcessIt->second.find( unitIndex );
		if ( findUnitIt != findProcessIt->second.end()) {

			result = findUnitIt->second;
		}
	}

	return result;
}

//=========================================================
// このレコードある？ なければ作成。
//=========================================================
int  ReadTextManager::GetRecord ( string processLabel, int unitIndex ) {

	int result = 0;

	// ある？
	map < string, map <int, int> >::iterator findItProcess = _readData.find ( processLabel );

	// なければ、初期値を入れる
	if ( findItProcess == _readData.end() ) {

		map<int, int> unitData;
		_readData[processLabel] = unitData;

		findItProcess = _readData.find ( processLabel );
	}

	// ある？
	if ( findItProcess->second.find( unitIndex ) == findItProcess->second.end() ) {

		// なければ、初期値を入れる。
		findItProcess->second[unitIndex] = 0;

	} else {
		result = findItProcess->second.find(unitIndex)->second;
	}

	return result;
}




//=========================================================
// セーブデータ作成
//=========================================================
vector<ReadTextManager::SaveData> ReadTextManager::GetSaveData () {

	vector<ReadTextManager::SaveData> result;

	//map < string, map <int, int> > _readData

	for ( map < string, map <int, int> >::iterator itProcess = _readData.begin();  itProcess != _readData.end(); ++itProcess ) {

		string processLabel = itProcess->first;

		for ( map<int, int>::iterator itUnit = itProcess->second.begin(); itUnit != itProcess->second.end(); ++itUnit ) {

			int unitIndex   = itUnit->first;
			int byCharIndex = itUnit->second;

			ReadTextManager::SaveData saveData;
			saveData.processLabel = processLabel;
			saveData.unitIndex    = unitIndex;
			saveData.byCharIndex  = byCharIndex;

			result.push_back ( saveData );
		}

	}

	return result;
}
//=========================================================
// ロード
//=========================================================
void ReadTextManager::Load ( vector<ReadTextManager::SaveData> &saveDataList ) {

	///// まずは、手元にあるデータを消しまして、
	_readData.clear();

	///// 受け取るのです。
	for ( unsigned int i = 0; i < saveDataList.size(); ++i ) {

		_readData[ saveDataList[i].processLabel ][ saveDataList[i].unitIndex ] = saveDataList[i].byCharIndex;
	}
}


