//=========================================================
//
// スクリプトで制御するボタン
//
//=========================================================

#ifndef _SCRIPT_BUTTON_
#define _SCRIPT_BUTTON_

#include "../GUI_SFML/Button.h"
#include <SFML/Graphics.hpp>

class ScriptButton : public GUI_SFML::Button {

public:
	ScriptButton(string label, sf::Vector2f size, int labelFontSize = 14) : GUI_SFML::Button( label,  size, labelFontSize) {}
	~ScriptButton() {}

	void   SetJumpToLabel ( string arg ) { _jumpToLabel = arg; }
	string GetJumpToLabel ()             { return _jumpToLabel; }
	void   SetName ( string arg ) { _name = arg; }
	string GetName ()             { return _name; }


	struct SaveData {

		sf::Vector2f position;
		string       label;
		sf::Vector2f size;
		int          fontSize;
		bool         isVisible;
		string       jumpToLabel;
		string       name;
	};
	SaveData GetSaveData ();
	static ScriptButton* Load ( SaveData &saveData );

private:

	///// 押されたときに呼び出すサブルーチンのプロセスラベル
	string _jumpToLabel;

	///// このボタンの名前。作成後に操作したいかもしれない
	string _name;

};
#endif