//=========================================================
//
// スクリプトのプロセス
//
//=========================================================

#ifndef _SCRIPT_PROCESS_
#define _SCRIPT_PROCESS_

#include <vector>
using namespace std;

#include "ScriptUnit.h"

struct ScriptProcess {

	string label;                // このプロセスの名前
	//string referingProcessLabel; // このプロセスを呼び出しているプロセスのラベル：空文字はルートということ
	ScriptProcess *referingProcess; //呼び出し元プロセス。NULLならばルートということ

	vector < ScriptUnit > _unitList; // ユニットリスト
	int currentUnitIndex;            // 現在実行中のユニット番号

	ScriptProcess () {

		label = "";
		currentUnitIndex = -1; // 初期状態。この「次」が、_unitListの先頭を指すこととなる。

		//referingProcessLabel = "";
		referingProcess = NULL;
	}

	///// デストラクタ
	~ScriptProcess() {
		
		printf ( "スクリプトプロセス解放 label = [%s]\n", label.c_str() );
		
		// 「現在実行中の」最下層のサブルーチンを削除すれば、ルートまで、順を追って削除される、という予定。
		delete referingProcess;
	}
};

///// セーブデータ
struct ScriptProcess_SaveData {

	string label;                    // スクリプトファイルに定義されているラベル。
	//string referingProcessLabel;   // 呼び出し元は、プロセス自身では記録できないか。ロード時の加減で、いいぐあいに再現していただく。
	int    currentUnitIndex;         // どのユニットを実行中であったか。

	ScriptProcess_SaveData () {
		label = "";
		//referingProcessLabel = "";
		currentUnitIndex = -1;
	}
	ScriptProcess_SaveData ( ScriptProcess &scriptProcess) {
		label                = scriptProcess.label;
		//referingProcessLabel = scriptProcess.referingProcessLabel;
		currentUnitIndex     = scriptProcess.currentUnitIndex;
	}

};

#endif
