//=========================================================
//
// テキストラベル
//
//=========================================================

#include "TextLabel.h"
#include "../GUI_SFML/SFML_Utils.h"

using namespace GUI_SFML;

//=========================================================
// コンストラクタ
//=========================================================
TextLabel::TextLabel ( string name ) {
	
	_name = name;
	_string = "";
	
}

//=========================================================
// デストラクタ
//=========================================================
TextLabel::~TextLabel() {
	// 処理なし？
}
	
//=========================================================
// 更新
//=========================================================
void TextLabel::Update(sf::RenderWindow &window, sf::Vector2f pos) {
	
	_text.setPosition(pos);
	
	Update( window );
}
void TextLabel::Update(sf::RenderWindow &window) {
	
	// 処理なし？
}



//=========================================================
// 描画
//=========================================================
void TextLabel::Draw(sf::RenderWindow &window) {
	
	window.draw(_text);
}

//=========================================================
// 文字列をセット
//=========================================================
void TextLabel::SetFont ( sf::Font &font ) {
	
	_text.setFont(font);
}
//=========================================================
// 文字列をセット
//=========================================================
void TextLabel::SetText ( string text, sf::Font &font ) {
	
	_text.setFont(font);
	_text.setString ( SFML_Utils::GetSfString ( text ) );
	
	// ロード用のメモ
	_string = text;
}
///// フォントを既に設定してあるなら
void TextLabel::SetText ( string text ) {
	
	_text.setString ( SFML_Utils::GetSfString ( text) );
	
	// ロード用のメモ
	_string = text;	
}

//=========================================================
// 色セット
//=========================================================
void TextLabel::SetColor    ( sf::Color color ) {
	_text.setColor(color);
}
void TextLabel::SetColor    ( string color ) {
	_text.setColor ( SFML_Utils::Convert_string_to_color(color));
}

//=========================================================
// サイズセット
//=========================================================
void TextLabel::SetSize     ( int size ) {
	_text.setCharacterSize(size);
}

//=========================================================
// 位置セット
//=========================================================
void TextLabel::SetPosition ( sf::Vector2f pos ) {
	_text.setPosition(pos);
}

//=========================================================
// 見た目上のサイズを取得
//=========================================================
sf::Vector2f TextLabel::GetBoundarySize () {
	
	sf::Vector2f result;
	
	result.x = _text.getGlobalBounds().width;
	result.y = _text.getGlobalBounds().height;
	
	return result;
}
	
//=========================================================
// ロードに必要なデータを取得
//=========================================================
TextLabel::SaveData TextLabel::GetSaveData () {
	
	TextLabel::SaveData result;
	
	/*	
	struct SaveData {
		
		string name;
		sf::Vector2f position;
		int size;
		sf::Color color;
		string text;
	};
	*/	
	result.name = _name;
	result.position = _text.getPosition();
	result.size     = _text.getCharacterSize();
	result.color    = _text.getColor();
	result.text     = _string;
	
	return result;
}









