//=========================================================
//
// アニメーションを表示するだけのエフェクト
//
//=========================================================

#include "Effect_Animation.h"

//=========================================================
// コンストラクタ
//=========================================================
Effect_Animation::Effect_Animation ( GUI_SFML::Animation *animation ) {

	_animation = animation;
	
	_frameCount = 0;
	_isEnd = false;
}

//=========================================================
// デストラクタ
//=========================================================
Effect_Animation::~Effect_Animation() {

	delete _animation;
}

//=========================================================
// 更新
//=========================================================
bool Effect_Animation::Update(sf::RenderWindow &window) {

	if (!_animation->IsActive()) {
		_isEnd = true;
	}

	// 初回
	if ( _frameCount = 0 ) {
		_animation->Update(window);
	}

	_animation->Update(window);

	++_frameCount;

	return _isEnd;
}

//=========================================================
// 描画　
//=========================================================
void Effect_Animation::Draw(sf::RenderWindow &window) {

	_animation->Draw(window);
}

