//=========================================================
//
// カットインエフェクト実験
//
//=========================================================

#include "Effect_CuiInTest001.h"
#include "Define.h"
#include "../Utils/Utils_Cal.h"

//=========================================================
// コンストラクタ
//=========================================================
Effect_CuiInTest001::Effect_CuiInTest001() {

	printf ("カットインエフェクトテスト開始\n");


	_animationBack = new GUI_SFML::Animation();
	_animationBack->Init("./effect/cutInTest001/define.dat");
	_animationBack->SetPosition ( sf::Vector2f ( APPLICATION::WINDOW_SIZE::WIDTH/2, APPLICATION::WINDOW_SIZE::HEIGHT/2 ) );

	_image_Back.loadFromFile ( "./effect/cutInTest001/gra_effect_screenC.png" );
	_texture_Back.loadFromImage ( _image_Back );
	_sprite_Back.setTexture ( _texture_Back );

	_sprite_Back.setPosition( sf::Vector2f(0,0) );

	_sprite_Back.scale ( 800.0f / _image_Back.getSize().x, 600.0f / _image_Back.getSize().y );

	/*
	_rect_Back.left = 0;
	_rect_Back.top  = 0;
	_rect_Back.width  = 800;
	_rect_Back.height = 600;

	_sprite_Back.setTextureRect (_rect_Back);
	*/

	//_character = ImageSet ( "./effect/cutInTest001/character.png" );

	_character.image.loadFromFile("./effect/cutInTest001/character.png");
	_character.texture.loadFromImage(_character.image);
	_character.sprite.setTexture(_character.texture);

	//_character.sprite.setColor ( sf::Color(255,255,255,150) );

	_character.ToCenter();

	_character.sprite.setScale ( 2.0f, 2.0f );
	_characterPos = sf::Vector2f ( 100, 300 );
	_character.sprite.setPosition ( _characterPos );

	//int _charcter_FromX;
	_charcter_ToX = 200;

	_frameCount = 0;

	_isEnd = false;
}

//=========================================================
// デストラクタ
//=========================================================
Effect_CuiInTest001::~Effect_CuiInTest001() {



	printf ("カットインエフェクトテスト終了\n");


	//delete _animationBack;

}

//=========================================================
// 更新
//=========================================================
bool Effect_CuiInTest001::Update(sf::RenderWindow &window) {

	if ( _isEnd ) { return _isEnd; }

	_animationBack->Update(window);

	if ( !_animationBack->IsActive() ) {
		_isEnd = true;
	}

	int nextX = Utils_Cal::Nearlize ( _character.sprite.getPosition().x, _charcter_ToX, 5 );
	_character.sprite.setPosition ( nextX, _character.sprite.getPosition().y );

	if ( nextX == _charcter_ToX ) {

		++_frameCount;
		if ( _frameCount > 60 ) {
			_isEnd = true;
		}
	}
	/*
	_rect_Back.left += 10;
	if ( _rect_Back.left + _rect_Back.width > _image_Back.getSize().x ) {
		_isEnd = true;
	} else {
		_sprite_Back.setTextureRect (_rect_Back);
	}
	*/

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_CuiInTest001::Draw(sf::RenderWindow &window) {

	_animationBack->Draw(window);

	window.draw ( _character.sprite );

	//window.draw ( _sprite_Back );

}







