//=========================================================
//
// カットインエフェクト実験
//
//=========================================================

#include "Effect_CuiInTest002.h"
#include "Define.h"
#include "../Utils/Utils_Cal.h"
#include "../GUI_SFML/SoundPlayer.h"

//=========================================================
// コンストラクタ
//=========================================================
Effect_CuiInTest002::Effect_CuiInTest002() {

	printf ("カットインエフェクトテスト開始\n");

	_imageFace.image.loadFromFile    ("./effect/cutInTest002/face2-2.png");
	_imageFace.image.createMaskFromColor ( sf::Color(0,255,0,255) );
	_imageFace.texture.loadFromImage (_imageFace.image);
	_imageFace.sprite.setTexture     (_imageFace.texture);

	_imageBack.image.loadFromFile    ("./effect/cutInTest002/gra_effect_screenC_fit.png");
	_imageBack.texture.loadFromImage (_imageBack.image);
	_imageBack.sprite.setTexture     (_imageBack.texture);
	_imageBack.sprite.setColor       ( sf::Color ( 255,255,255,200 ) );

	_rect_Back.left = 0;
	_rect_Back.top  = 0;
	_rect_Back.width  = _imageBack.image.getSize().x;
	_rect_Back.height = _imageFace.image.getSize().y;

	_imageBack.sprite.setTextureRect ( _rect_Back );
	

	_positionBack = sf::Vector2f ( 0, 200 );
	_positionFace = sf::Vector2f ( -200, 200 );

	_imageBack.sprite.setPosition ( _positionBack );
	_imageFace.sprite.setPosition ( _positionFace );


	_state = "";

	_frameCount = 0;

	_isEnd = false;


	_textMessageWindow = NULL;
}

//=========================================================
// デストラクタ
//=========================================================
Effect_CuiInTest002::~Effect_CuiInTest002() {



	printf ("カットインエフェクトテスト終了\n");


	///// 消しちゃいますよ。消しちゃいますよー。消してるってことを忘れないで！ 忘れないで！
	delete _textMessageWindow;

	//delete _animationBack;

}

//=========================================================
// 更新
//=========================================================
bool Effect_CuiInTest002::Update(sf::RenderWindow &window) {

	if ( _isEnd ) { return _isEnd; }

	
	///// 背景を動かす
	_rect_Back.top += 100;
	if ( _rect_Back.top + _rect_Back.height > _imageBack.image.getSize().y ) {
		_rect_Back.top = 0;
	}
	_imageBack.sprite.setTextureRect ( _rect_Back );



	if ( _state == "" ) {

		_state = "1";

		//GUI_SFML::SoundPlayer::Play ( "./effect/cutInTest002/korededouda_01.wav" );


		if ( _textMessageWindow != NULL ) {
			_textMessageWindow->AddText_asFinishedText("そこだ！");
		}


	} else if ( _state == "1" ) {

		_positionFace.x += 20;

		if ( _positionFace.x >= 200 ) {
			_state = "2";
			_frameCount = 0;
		}

	} else if ( _state == "2" ) {

		_frameCount += 1;

		if ( _frameCount >= 20 ) {
			_state = "3";

			_imageFace.image.loadFromFile    ("./effect/cutInTest002/face2.png");
			_imageFace.image.createMaskFromColor ( sf::Color(0,255,0,255) );
			_imageFace.texture.loadFromImage (_imageFace.image);
			_imageFace.sprite.setTexture     (_imageFace.texture);
		}

	} else if ( _state == "3" ) {

		_positionFace.x += 20;

		if ( _positionFace.x >= 1000 ) {
			_state = "4";
		}

	} else if ( _state == "4" ) {

		_isEnd = true;
	}



	_imageBack.sprite.setPosition ( _positionBack );
	_imageFace.sprite.setPosition ( _positionFace );


	if ( _textMessageWindow != NULL ) {
		_textMessageWindow->Update(window);
	}

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_CuiInTest002::Draw(sf::RenderWindow &window) {

	window.draw ( _imageBack.sprite  );
	window.draw ( _imageFace.sprite  );


	if ( _textMessageWindow != NULL ) {
		_textMessageWindow->Draw(window);
	}

}







