//=========================================================
//
// カットインエフェクト：SPEAK
//
// これはちょっともう非推奨ってことで
//
// 着手直前のリアクションとしてセリフを言って、その後の着手でエフェクトをつければ同じことが実現できる。
//
//=========================================================

#include "Effect_CutIn_SPEAK.h"
#include "Define.h"
#include "../Utils/Utils_Cal.h"
#include "../Utils/Utils_Convert.h"
#include "../GUI_SFML/SoundPlayer.h"
#include "../Utils/Utils_Others.h"
#include "../Utils/Utils_String.h"


//=========================================================
// コンストラクタ
//=========================================================
Effect_CutIn_SPEAK::Effect_CutIn_SPEAK ( DelegateBase *endMethod, int effectLevel, GUI_SFML::TextMessageWindow *textMessageWindow, map<string, string> parameters ) {

	printf ("カットインエフェクト：SPEAK\n");

	// 引数を受け取る
	_textMessageWindow = textMessageWindow;
	_endMethod         = endMethod;
	_effectLevel       = effectLevel;

	map<int, LineData> lineDatas;
	for ( map<string, string>::iterator it = parameters.begin(); it != parameters.end(); ++it ) {

		string key   = it->first;
		string value = it->second;

		/*
			lineData_000
		*/
		if ( Utils_String::IsContainsPattern ( key, "lineData" ) ) {

			vector<string> list = Utils_String::Split ( key, "_" );
			string num = ( list.size() >= 2 ) ? list[1] : "";

			lineDatas[ Utils_Convert::String_to_Int(num) ] = GetLineDataFromString ( value );
		}
	}

	/*
		map<int, LineData> lineDatas;
		添え字の順番に並び替える
	*/
	vector<int> lineIndexList;
	for ( map<int, LineData>::iterator it = lineDatas.begin(); it != lineDatas.end(); ++it) {
		lineIndexList.push_back ( it->first );
	}

	// 昇順ソート
	std::sort( lineIndexList.begin(), lineIndexList.end() );

	for ( unsigned int i = 0; i < lineIndexList.size(); ++i ) {

		_lineDataList.push_back ( lineDatas[ lineIndexList[i] ] );
	}

	///// セリフデータが１つもない？
	if ( _lineDataList.size() == 0 ) {
		_isEnd = true;

	///// 最初のセリフをセット
	} else {
		_currentLineNumber = 0;
		_frameCount_SinceCurrentLine = 0;
		_isEnd = false;
	}
}

//=========================================================
// セリフデータを文字列から生成
//=========================================================
Effect_CutIn_SPEAK::LineData Effect_CutIn_SPEAK::GetLineDataFromString ( string str ) {

	LineData result;

	vector<string> list = Utils_String::Split ( str, ":" );

	if ( list.size() >= 2 ) {

		result.frameCount = Utils_Convert::String_to_Int ( list[0] );
		result.line       = list[1];

	} else {
		printf ("セリフデータがおかしなことになってます [ %s ]\n", str.c_str());
	}

	return result;
}


//=========================================================
// デストラクタ
//=========================================================
Effect_CutIn_SPEAK::~Effect_CutIn_SPEAK() {

	printf ("カットインエフェクト SPEAK 終了\n");

	///// 消しちゃいますよ。消しちゃいますよー。消してるってことを忘れないで！ 忘れないで！
	//delete _textMessageWindow;

}

//=========================================================
// 更新
//=========================================================
bool Effect_CutIn_SPEAK::Update(sf::RenderWindow &window) {

	if ( _isEnd ) { return _isEnd; }

	///// 全部のセリフが終了した？
	if ( _currentLineNumber >= _lineDataList.size() ) {

		_isEnd = true;

		// エフェクトを単体でテストしたいかもしれないので、NULLでも動作できることにする。
		if (_endMethod != NULL) {
			(*_endMethod)( _effectLevel );
		}

		return _isEnd;
	}


	///// 今のセリフになったばかり？
	if ( _frameCount_SinceCurrentLine == 0 ) {

		// セリフを表示する
		_textMessageWindow->AddText_asFinishedText ( _lineDataList[_currentLineNumber].line );
	}

	///// フレームカウントを進める
	++_frameCount_SinceCurrentLine;

	///// 今のセリフ、終了？
	if ( _frameCount_SinceCurrentLine > _lineDataList[_currentLineNumber].frameCount ) {

		// 次のセリフへ
		++_currentLineNumber;
		_frameCount_SinceCurrentLine = 0;
	}

	

	if ( _textMessageWindow != NULL ) {
		_textMessageWindow->Update(window);
	}

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_CutIn_SPEAK::Draw(sf::RenderWindow &window) {

	if ( _textMessageWindow != NULL ) {
		_textMessageWindow->Draw(window);
	}

}







