//=========================================================
//
// エフェクト：カーテン閉じる
// つまり、試合開始前後のあれ
//
//=========================================================

#ifndef _EFFECT_CURTAIN_CLOSE_
#define _EFFECT_CURTAIN_CLOSE_

#include "IEffect.h"

//=========================================================
// カーテン閉じエフェクトとしての最低限のインターフェイス
//=========================================================
class Effect_CurtainClose : public IEffect {

public:
	///// 閉まりきった？
	virtual bool IsClosed() = 0;

};

//=========================================================
// カーテン閉じエフェクト001：実装
//=========================================================
class Effect_CurtainClose_001 : public Effect_CurtainClose {

public:

	Effect_CurtainClose_001();
	~Effect_CurtainClose_001();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

	///// 閉まりきった？
	bool IsClosed() { return _isClosed; }
	
	void SetWaitFrameAfterClose(int value) { _maxFrameCount_SinceClosed = value; }

private:

	bool _isClosed;
	bool _isEnd;

	// カーテンとしての実体。徐々に色を濃くする
	sf::RectangleShape _screenShape;

	sf::Color _currentColor;

	// 閉まりきってからのフレームカウント
	int _frameCount_SinceClosed;
	int _maxFrameCount_SinceClosed;

};

//=========================================================
// カーテン閉じエフェクト：実装
//=========================================================
class Effect_CurtainClose_002 : public Effect_CurtainClose {

public:

	Effect_CurtainClose_002();
	~Effect_CurtainClose_002();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

	///// 閉まりきった？
	bool IsClosed() { return _isClosed; }

private:

	bool _isClosed;
	bool _isEnd;

	// カーテンとしての実体。徐々に色を濃くする
	sf::RectangleShape _screenShape;

	sf::Color _currentColor;

	// 閉まりきってからのフレームカウント
	int _frameCount_SinceClosed;

};

#endif












