//=========================================================
//
// カットインエフェクト：SPEAK
//
//=========================================================

#include "IEffect.h"

#include <./SFML/Graphics.hpp>
#include "../GUI_SFML/Animation.h"
#include "../GUI_SFML/TextMessageWindow.h"
#include <string>
#include <map>
#include <vector>
#include "Delegate.h"

using namespace std;


class Effect_CutIn_SPEAK : public IEffect {

public:

	Effect_CutIn_SPEAK ( DelegateBase *endMethod, int effectLevel, GUI_SFML::TextMessageWindow *textMessageWindow, map<string, string> parameters );
	~Effect_CutIn_SPEAK ();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

private:

	///// セリフデータ
	struct LineData {
		string line;       // セリフ文字列
		int    frameCount; // 持続フレーム数

	};


	vector<LineData> _lineDataList;

	///// 現在のセリフを表示してから何フレーム経過したか。
	int _frameCount_SinceCurrentLine;

	///// 今、いくつめのセリフ？
	int _currentLineNumber;


	// テキスト欄
	GUI_SFML::TextMessageWindow *_textMessageWindow;

	///// 終了時に呼ぶメソッド：つまり着手・エフェクトレベル(int) を１つ渡すメソッド。
	DelegateBase *_endMethod;
	int           _effectLevel;

	bool _isEnd;
	
	//=========================================================
	// セリフデータを文字列から生成
	//=========================================================
	LineData GetLineDataFromString ( string str );
};

