//=========================================================
//
// 衝撃波を続けて出す
//
//=========================================================

#include "Effect_ImpactWave_Rash.h"
#include "Application.h"
#include "EffectManager.h"


//=========================================================
// コンストラクタ
//=========================================================
Effect_Impact_Rash::Effect_Impact_Rash ( map<unsigned int, Effect_ImpactWave::Property> impactList ) {

	_impactList = impactList;
	_isEnd = false;
	_frameCount = 0;
}

//=========================================================
// デストラクタ
//=========================================================
Effect_Impact_Rash::~Effect_Impact_Rash () {

}

//=========================================================
// 更新
//=========================================================
bool Effect_Impact_Rash::Update(sf::RenderWindow &window) {

	if ( _isEnd ) {
		return _isEnd;
	}

	map<unsigned int, Effect_ImpactWave::Property>::iterator findIt = _impactList.find ( _frameCount );
	if ( findIt != _impactList.end() ) {

		Effect_ImpactWave *effect = new Effect_ImpactWave ( findIt->second );
		Application::GetInstance()->_effectManager->Add ( effect );

		_impactList.erase ( findIt );
	}

	if ( _impactList.size() == 0 ) {
		_isEnd = true;
	}

	++_frameCount;

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_Impact_Rash::Draw(sf::RenderWindow &window) {

	// なし
}
