//=========================================================
//
// 千日手メッセージ
//
//=========================================================

#include "Effect_RepetitionMoveMessage.h"
#include "../GUI_SFML/SFML_Utils.h"
#include "Define.h"
#include "../Application.h"
#include "../GUI_SFML/TextImageFactory.h"
#include "../GUI_SFML/SFML_Utils.h"
#include "../GUI_SFML/SoundPlayer.h"


using namespace GUI_SFML;

//=========================================================
// コンストラクタ
//=========================================================
Effect_RepetitionMoveMessage::Effect_RepetitionMoveMessage () {
	
	_position = sf::Vector2f ( APPLICATION::WINDOW_SIZE::WIDTH / 2.0f, APPLICATION::WINDOW_SIZE::HEIGHT / 2.0f + 5.0f );
	
	_text.setString ( SFML_Utils::GetSfString ( "千日手です。別の手を選択してください。" ) );
	
	_text.setFont ( TextImageFactory::_font );
	
	int fontSize = 24;
	_text.setCharacterSize ( fontSize );
	_text.setColor ( sf::Color::White );

	//printf ( "%f,%f\n" , _text.getGlobalBounds().width, _text.getGlobalBounds().height );
	
	//printf ("%f\n", adjustValue);
	
	float adjustValue = fontSize/10.0f; // 適当。
	_text.setOrigin ( _text.getGlobalBounds().width / 2.0f, _text.getGlobalBounds().height / 2.0f + adjustValue);
	_text.setPosition(_position);


	sf::Vector2f rectSize = sf::Vector2f( _text.getGlobalBounds().width + (fontSize * 2) , _text.getGlobalBounds().height + (fontSize * 2));
	//sf::Vector2f rectSize = sf::Vector2f( _text.getGlobalBounds().width, _text.getGlobalBounds().height);
	_backRect = sf::RectangleShape ( rectSize );
	_backRect.setOutlineColor ( sf::Color::Blue );
	_backRect.setFillColor ( sf::Color ( 100,100,250,255 ) );
	_backRect.setOutlineThickness(1.0f);
	_backRect.setOrigin ( _backRect.getGlobalBounds().width / 2.0f, _backRect.getGlobalBounds().height / 2.0f );
	
	
	_sound = "./sound/se_good_pk01/push11.wav";
	
	_isEnd = false;
	_isFirst = true;

}


//=========================================================
// デストラクタ
//=========================================================
Effect_RepetitionMoveMessage::~Effect_RepetitionMoveMessage() {
	
}

//=========================================================
// 更新
//=========================================================
bool Effect_RepetitionMoveMessage::Update(sf::RenderWindow &window) {
	
	if ( _isFirst ) {
		_isFirst = false;
		GUI_SFML::SoundPlayer::Play ( _sound );
	}
	
	
	sf::Color textColor =  _text.getColor();
	textColor.a -= 3;
	if ( textColor.a <= 0 ) { textColor.a = 0;}
	_text.setColor ( textColor );

	sf::Color backFillColor =  _backRect.getFillColor();
	backFillColor.a -= 3;
	if ( backFillColor.a <= 0 ) { backFillColor.a = 0;}
	_backRect.setFillColor ( backFillColor );

	sf::Color backOutlineColor =  _backRect.getOutlineColor();
	backOutlineColor.a -= 3;
	if ( backOutlineColor.a <= 0 ) { backOutlineColor.a = 0;}
	_backRect.setOutlineColor ( backOutlineColor );

	if ( textColor.a <= 0 || backFillColor.a <= 0 || backOutlineColor.a <= 0) {
		_isEnd = true;
		return _isEnd;
	}
	
	// 移動
	_position += sf::Vector2f ( 0.0f, -1.0f );
	
	// カメラに合わせて座標を調整
	sf::Vector2f screenPos = Application::GetInstance()->_window.mapPixelToCoords ( sf::Vector2i ( _position.x, _position.y ) );
	
	
	_backRect.setPosition ( screenPos );
	_text.setPosition ( screenPos );
	

	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_RepetitionMoveMessage::Draw(sf::RenderWindow &window) {
	
	if ( !_isEnd ) {
		window.draw(_backRect);
		window.draw(_text);
	}
}

