//=========================================================
//
// Effect to transite Scene (implement)
//
//=========================================================

#include "Effect_SceneTransition.h"
#include "Delegate.h"
#include "Application.h"


//=========================================================
// Constructor
//=========================================================
Effect_SceneTransition::Effect_SceneTransition( DelegateBase *event_Transition, string nextSceneName ) {

	_event_Transition = event_Transition;
	_nextSceneName    = nextSceneName;

	//_state = EFFECT::STATE::NONE;
	_isDarker = true;

	unsigned int windowSize_w = Application::GetInstance()->_window.getSize().x;
	unsigned int windowSize_h = Application::GetInstance()->_window.getSize().y;


	_shape = sf::RectangleShape ( sf::Vector2f(windowSize_w, windowSize_h) );
	_shape.setOutlineThickness ( 0.0f );
	_shape.setFillColor ( sf::Color(0,0,0,0) );




}
//=========================================================
// Destructor
//=========================================================
Effect_SceneTransition::~Effect_SceneTransition() {

}

//=========================================================
// Update
//=========================================================
bool Effect_SceneTransition::Update(sf::RenderWindow &window) {

	bool isEnd = false;

	//if (_state == EFFECT::STATE::END) {
	//	return true;
	//}

	sf::Color color = _shape.getFillColor();

	if (_isDarker) {

		int alpha = color.a;
		alpha += 15;

		if (alpha >= 255) {
			alpha = 255;
			_isDarker = false;

			(*_event_Transition)(_nextSceneName);

		}
		color.a = alpha;

	} else {

		int alpha = color.a;
		alpha -= 10;

		if (alpha <= 0) {
			alpha = 0;
			//_state = EFFECT::STATE::END;
			isEnd = true;
		}
		color.a = alpha;
	}

	_shape.setFillColor( color );


	return isEnd;
}

//=========================================================
// Draw
//=========================================================
void Effect_SceneTransition::Draw(sf::RenderWindow &window) {

	//if (_state == EFFECT::STATE::END) {
	//	return;
	//}

	const sf::View& currentView = window.getView();
	const sf::View& defaultView = window.getDefaultView();

	window.setView(defaultView);
	window.draw(_shape);

	window.setView(currentView);

}






