//=========================================================
//
// システムメッセージ
//
//=========================================================

#include "Effect_SystemMessage.h"
#include "../GUI_SFML/SFML_Utils.h"
#include "Define.h"
#include "../Application.h"

int Effect_SystemMessage::CURRENT_MESSAGE_NUM = 0;
int Effect_SystemMessage::MAX_MESSAGE_NUM = 0;

	
//=========================================================
// コンストラクタ
//=========================================================
Effect_SystemMessage::Effect_SystemMessage ( string message, sf::Font &font ) {
	
	_myIndex = MAX_MESSAGE_NUM;
	
	CURRENT_MESSAGE_NUM += 1;
	MAX_MESSAGE_NUM += 1;
	
	_text.setFont ( font );
	
	_text.setString ( GUI_SFML::SFML_Utils::GetSfString( message ) );
	
	_text.setCharacterSize ( 16 );
	_text.setColor ( sf::Color::White );
	
	_size = sf::Vector2f( _text.getGlobalBounds().width * 1.5f , 30.0f);
	_position = sf::Vector2f ( APPLICATION::WINDOW_SIZE::WIDTH - _size.x, -_size.y );
	
	_base = sf::RectangleShape ( _size );
	_base.setOutlineColor ( sf::Color::Black );
	_base.setFillColor ( sf::Color ( 50,50,50,200 ) );
	_base.setOutlineThickness(1.0f);
	
	_count = 0;
	
	_isEnd = false;

}


//=========================================================
// デストラクタ
//=========================================================
Effect_SystemMessage::~Effect_SystemMessage() {
	
	CURRENT_MESSAGE_NUM -= 1;
	
	if ( CURRENT_MESSAGE_NUM <= 0 ) {
		CURRENT_MESSAGE_NUM = 0;
		MAX_MESSAGE_NUM = 0;
	}
}

//=========================================================
// 更新
//=========================================================
bool Effect_SystemMessage::Update(sf::RenderWindow &window) {
	
	if ( _position.y < 0 && _count == 0) {
		_position.y += 3.0f;
	}
	if ( _position.y >= 0.0f ) {
		++_count;
	}
	if (  _count > 60 ) {
		_position.y -= 3.0f;
	}
	if ( _position.y < (_size.y * -1.0f) ) {
		_isEnd = true;
	}
	
	// カメラに合わせて座標を調整
	sf::Vector2i screenPos = Application::GetInstance()->_window.mapCoordsToPixel( 

		sf::Vector2f ( 
			_position.x, 
			_position.y + (_myIndex ) * _base.getGlobalBounds().height
		),
		Application::GetInstance()->_window.getDefaultView()
	);
	
	_base.setPosition ( screenPos.x, screenPos.y );
	_text.setPosition 
	(
		sf::Vector2f(
			screenPos.x + (int)( (_size.x - _text.getGlobalBounds().width) / 2.0f )
			,
			screenPos.y + (int)( (_size.y - _text.getGlobalBounds().height) / 2.0f )
		)
	);
	
	/*
	++_count;
	
	if (_count > 60 ) {
		
		_isEnd = true;
	}
	*/
	return _isEnd;
}

//=========================================================
// 描画
//=========================================================
void Effect_SystemMessage::Draw(sf::RenderWindow &window) {

	window.draw(_base);
	window.draw(_text);

}

