//=========================================================
//
// カード取得時のエフェクト
//
//=========================================================

#ifndef _EFFECT_TAKE_CARD_ENERGY_
#define _EFFECT_TAKE_CARD_ENERGY_

#include "IEffect.h"
#include "../GUI_SFML/Animation.h"

#include <vector>

using namespace std;

class Effect_TakeCardEnergy : public IEffect {

public:

	struct Property {
		int          particleNumber;      // パーティクル数
		int          firstRadius;         // 初期半径
		int          minRadius;           // 最終半径
		float        speed;               // 回転速度（radian）１フレームごとにこの数を加算する
		sf::Vector2f position;            // 位置（中心）
		int          radiusShrinkSpeed;   // 半径を縮める速度
		string       animationConfigFile; 
	};

	Effect_TakeCardEnergy ( Property prop );
	~Effect_TakeCardEnergy ();

	bool Update(sf::RenderWindow &window);
	void Draw(sf::RenderWindow &window);

	///// 終わらせる
	void End() { _isEnd = true; }

	///// 半径が縮まりきってる？
	bool IsRadiusMin() { return ( _radius <= _prop.minRadius ); }

	///// アニメーション進める
	void AnimationGo() { _isAnimationGo = true; }

	///// 位置セット
	void SetPosition ( sf::Vector2f pos ) { _position = pos; }

private:

	struct Particle {
		
		float x;
		float y;
		float radian;
		//sf::CircleShape circle;

		//GUI_SFML::Animation *animation;
	};

	GUI_SFML::Animation *_animation;

	Property _prop;

	bool _isEnd;
	sf::Vector2f _position;

	bool _isAnimationGo;

	int _radius;
	vector < Particle > _particleList;

};
#endif
