//=========================================================
//
// 盤
//
//=========================================================

#ifndef _BOARD_
#define _BOARD_

#include <map>
#include <vector>
#include <SFML/Graphics.hpp>

using namespace std;

class Grid;
class Piece;
class Card;

class Board {

public:

	Board( int width, int height );
	static Board* GetInstance( string outPutSizeData );
	~Board();

	void Update(sf::RenderWindow &window, sf::Vector2f pos);
	void Draw(sf::RenderWindow &window);

	Grid* GetGrid( int x, int y );
	Grid* GetMouseOverGrid();

	sf::Vector2i GetMouseOverPosition();

	int GetWidth() { return ( _gridList.size() > 0 ) ? _gridList[0].size() : 0; }
	int GetHeight() { return _gridList.size();}

	int GetBaseWidth () { return _base.getSize().x; }
	int GetBaseHeight() { return _base.getSize().y; }

	string Output();
	string Output_Size();
	void Read( string data );


	///// 全グリッドが欲しいんですぅぅぅ！ 誰にだってそんなときがあるだろう？ 俺にはある！ キミにもあるはずだ！ なぜならこの俺にあるのだから！
	vector< vector<Grid*> > GetAllGrid() { return _gridList;}
	
	///// ていうか全駒が欲しいんです。つまりそういうこととです。
	vector<Piece*> GetAllPieces();

	///// ていうか全カードが欲しいんです。つまりそういうこととです。
	vector<Card*> GetAllCards();
	
private:

	sf::RectangleShape _base;
	sf::Vector2f _baseMargin;
	
	vector< vector<Grid*> > _gridList;

	vector<Grid*> _gridList_DrawBase;
	vector<Grid*> _gridList_DrawCardPiece;

};
#endif

