//=========================================================
//
// Utils_Cal (declare)
//
//=========================================================


#ifndef _UTILS_CAL_
#define _UTILS_CAL_

#include <map>
#include <vector>
#include <string>
#include <set>

//#include <SFML/Window.hpp>
//#include <SFML/Graphics.hpp>

using namespace std;

class Utils_Cal {

public:

	//=========================================================
	// From -> To with the distance
	//=========================================================
	//static sf::Vector2f MoveTo ( sf::Vector2f from, sf::Vector2f to, float distance );
	static pair<float, float> MoveTo ( float from_x, float from_y, float to_x, float to_y, float distance );

	//=========================================================
	// Get Distance
	//=========================================================
	//static float GetDistance ( sf::Vector2f from, sf::Vector2f to );
	static float GetDistance ( float from_x, float from_y,  float to_x, float to_y);
	
	//=========================================================
	// Get Angle
	//=========================================================
	static float GetAngleOfLineBetweenTwoPoints(float p1X, float p1Y, float p2X, float p2Y);

	//=========================================================
	// Nearlize
	//=========================================================
	static float Nearlize( float from, float to, float distance );


	//=========================================================
	// 符号を求める
	//=========================================================
	static int Sign( int a );

	//=========================================================
	// int用のabs
	//=========================================================
	static unsigned int Abs( int a, int b );
	static unsigned int Abs( int a );

	//=========================================================
	// int用のpow
	// a^b
	//=========================================================
	static int Pow(int a, int b);

	//=========================================================
	// 乱数
	//=========================================================
	static int GetRandom( int max );
	static int GerRandom( int max );

	//==========================================================
	// コイントス
	// lot / all でくじ引きをして、あたりが出たら true
	//==========================================================
	static bool MultipleCoinToss ( int lot, int all );

	//=========================================================
	// Permutation
	//【引数】
	// left Ｐ right
	//=========================================================
	static int Permutation ( int left, int right );

	//=========================================================
	// 可変長引数で、最大値チェック
	//【引数】
	// argNum 引数の個数「この argNum 個の数の中で」
	//【結果】
	// 最初の引数が最大値だったら、true
	//=========================================================
	static bool IsMax ( int argNum, ... );

	//=========================================================
	// 重複なしで乱数
	//=========================================================
	static void GetRandom_WithoutDuplicate ( set<int> &result, unsigned int n, int min, int max );

	//==========================================================
	// 間に入っている
	// 真上を含むかどうか true で含む
	//==========================================================
	static bool IsBetween( int thisValue, int a, int b, bool isOverIncluded );

	//=========================================================
	// 無理やりな四捨五入というか整数値に丸める
	//=========================================================
	static void RoundWildly ( float & value );
};
#endif
